#include <config.h>
#include <gnome.h>
#include <libgnomeui/gnome-stock.h>
#include <libgnomeui/gnome-propertybox.h>
#include <gdk/gdkx.h>
#include <gdk_imlib.h>
#include <gtk/gtk.h>
#include <applet-widget.h>

#define COUNT_PRIORITY 3

#define TOOLTIP_TYPE_SMALL  _("x/y mailboxes contain new mail")
#define TOOLTIP_TYPE_MIDDLE _("sorted by priorities")
#define TOOLTIP_TYPE_LARGE  _("each mailbox separate")


/*#define NO_MAIL_ICON   0
  #define NEW_MAIL_ICON  1*/

typedef struct _mailbox MailBox;
typedef struct _mailbox_list MailBoxList;
typedef struct _gbox_applet GboxApplet;
typedef struct _icons Icons;

struct _gbox_applet {
  gchar          *no_mail_pix;
  gchar          *new_mail_pix[COUNT_PRIORITY];
  gchar          *mail_prog;
  GtkWidget      *image_win;
  GtkWidget      *mailcheck;
  GtkWidget      *main_button;
  GtkWidget      *gbox_applet;
  GtkStyle       *style;
  GdkImlibImage  *no_email_image;
  GdkPixmap      *no_email_pixmap;
  GdkBitmap      *no_email_mask;
  GdkImlibImage  *new_email_image[COUNT_PRIORITY];
  GdkPixmap      *new_email_pixmap[COUNT_PRIORITY];
  GdkBitmap      *new_email_mask[COUNT_PRIORITY];
  GtkWidget      *tip;
  GtkTooltips    *tooltip;
  int            style_beep;
  int            style_relief;
  int            show_tooltip;
  int            style_tooltip;
};

struct _mailbox {
  char *mailfile;
  char *nickname;
  int  size;
  int  interval;
  int  timer;
  int  priority;
  int  mail_in_box;
  MailBox *next;
};

struct _mailbox_list {
  MailBox *first_mb;
  MailBox *last_mb;
  int     new_count[COUNT_PRIORITY];
  int     box_count;
};

struct _icons {
  GtkWidget *no_mail;
  GtkWidget *pix_no_mail;
  gchar     *file_no_mail;
  GtkWidget *new_mail[COUNT_PRIORITY];
  GtkWidget *pix_new_mail[COUNT_PRIORITY];
  gchar     *file_new_mail[COUNT_PRIORITY];
};

void update_tooltip(void);
int check_mailbox(MailBox *mb);
gint timeout_callback( gpointer data );
void start_timer(void);
void stop_timer(void);
void load_image(gchar *file, GdkImlibImage **image, GdkPixmap **pixmap, GdkBitmap **mask);
void add_mailbox(char *file, char *nick, int interval, int prio);
int count_mailboxes_with_new_mail(void);
int count_mailboxes(void);
void change_mailbox(char *file, MailBox* new_box);
void remove_mailbox(char *file);
void remove_mailbox_by_index(int index);
MailBox *get_mailbox(int index);

void show_tooltip(GtkButton *button, gpointer user_data);
void hide_tooltip(GtkButton *button, gpointer user_data);
void store_iconfile(GtkFileSelection *selector, gpointer user_data);
void select_iconfile(GtkWidget* w, gpointer cbdata);
void store_mailbox(GtkFileSelection *selector, gpointer user_data);
void select_mailbox_cb(GtkWidget* w, gpointer cbdata);
void store_mailprog(GtkFileSelection *selector, gpointer user_data);
void select_mailprog(GtkWidget* w, gpointer cbdata);
void show_box_dialog(void);
void add_box_cb(GtkWidget* w, gpointer cbdata);
void edit_box_cb(GtkWidget* w, gpointer cbdata);
void remove_or_not(gint reply,gpointer data);
void remove_box_cb(GtkWidget* w, gpointer cbdata);
void copy_box_cb(GtkWidget* w, gpointer cbdata);
void text_changed(GtkWidget* w, gpointer cbdata);
void apply_prop_cb(GtkWidget* propertybox, gint page_num, gpointer data);
void close_prop_cb(GtkWidget* propertybox, gint page_num, gpointer data);
GtkWidget *create_page_global(void);
GtkWidget *create_page_prio(void);
GtkWidget *create_page_misc(void);
void applet_properties(AppletWidget *app, gpointer data);
